%define nx_version 4.0.590
%define driver_vendor  hp 
%define nx_name %{driver_vendor}-nx_nic
%define nx_release 2

Summary: HP NC-Series QLogic Driver for Linux
Name: %{nx_name}
Version: %{nx_version}
Release: %{nx_release}
Source0: %{name}-%{version}.tar.gz
Source1: hp_nx_nic_preamble
Source2: nx_nic_tools_post.sh
Source3: nx_nic_tools_preun.sh
Vendor: QLogic, Corporation.
Packager: Hewlett-Packard Company
License: GPL
Group: System Environment/Kernel
Provides: %{name}
URL: http://www.qlogic.com
Requires: kernel, bash, %{name}-tools = %{version}-%{release}
Buildroot: %{_tmppath}/%{name}-%{version}/bldroot

%if %{!?KVER:0}%{?KVER:1}
%define custom 1
%else
%define custom 0
%endif

%if "%{_vendor}" == "suse"
%if %{!?KVER:1}%{?KVER:0}
%ifarch x86_64
%define flav default smp xen kdump debug trace
%else
%define flav default smp xen kdump bigsmp xenpae pae debug kdumpae vmi vmipae trace
%endif
%endif

%if %{!?KVER:0}%{?KVER:1}
%define flav %(echo %{KVER} | awk -F"-" '{print $3}')
%define kverrel %(echo %{KVER} | awk -F"-" '{print $1"-"$2}')
%endif
%endif

%if "%{_vendor}" == "redhat"
%define rhel_version %(cat /etc/redhat-release | grep "Red Hat Enterprise" | cut -d " " -f 7)

%if %{!?KVER:0}%{?KVER:1}
%global kernel_version %{KVER}
%define rhel_maj %(echo %{rhel_version} | awk -F"." '{print $1}')
%if "%{rhel_maj}" == "6"
%define flav %(echo %{kernel_version} | awk -F"el6" '{print $2}' | awk -F"." '{print $3')
%else
%define flav %(echo %{kernel_version} | awk -F"el5" '{print $2}')
%endif

%if "%{flav}" == ""
%define flav default
%endif
%endif

%if %{!?KVER:1}%{?KVER:0}
%{!?kernel_version: %global kernel_version %( if [ -z "${KERNEL}" ]; then ( echo "`uname -r`"); else ( echo "${KERNEL}"); fi )}
%define flav ""
%endif
%endif


%define packinfo "This package contains the Linux driver of the Netxen's Nic"
%define debug_package %{nil}


%description
%{packinfo}

%define whatos %(echo `cat /etc/redhat-release 2> /dev/null | cut -f 1 -d " "`)
%define isddk %(echo `cat /etc/redhat-release 2> /dev/null | cut -f 2 -d " "`)

%define xen_srvr 0
%if "%{whatos}" == "XenServer"
%if "%{isddk}" == "DDK"
%define xen_srvr 1
%endif
%endif

%if "%{xen_srvr}" == "1"
%package kdump-%{kernel_version}
summary: QLogic kdump driver for NIC
Group: System/kernel

%description kdump-%{kernel_version}
%{packinfo}


%package xen-%{kernel_version}
summary: QLogic kdump driver for NIC
Group: System/kernel

%description xen-%{kernel_version}
%{packinfo}
%endif


%if "%{_vendor}" == "suse"
BuildRequires: kernel-source kernel-syms
%define kernel_source /usr/src/linux-obj/%{_target_cpu}
%{suse_kernel_module_package -x %flav -p %_sourcedir/hp_nx_nic_preamble}

%package KMP
summary: QLogic driver for NIC
Group: System/kernel

%description KMP
%{packinfo}

%else
%if "%{xen_srvr}" == "0"
BuildRequires: %kernel_module_package_buildreqs
%{kernel_module_package %flav -p %_sourcedir/hp_nx_nic_preamble}
%endif
%endif

%package tools
Summary: HP NC-Series QLogic user components for Linux driver
Group: System/Kernel

%description tools
Stuff for the QLogic Ethernet Kernel Module
for HP ProLiant systems.

%if %{custom}
%define flavors %{flav}
%else
%define flavors %{flavors_to_build}
%endif

%prep
%setup -n %{name}-%{version}
set -- *
mkdir source
mv "$@" source/
mkdir obj

%build
export EXTRA_CFLAGS='-DVERSION=\"%version\"'

%if "%{xen_srvr}" == "1"
%define kverrel %{kernel_version}
%define flavors xen kdump
%endif

for flavor in %flavors; do
rm -rf obj/$flavor
cp -r source obj/$flavor
export UNMSRC=$PWD/obj/$flavor

%define compile_with %{kernel_source $flavor}


%if "%{xen_srvr}" == "1"
%define compile_with /lib/modules/%{kverrel}$flavor/build/
%endif

make -C %{compile_with} modules M=$PWD/obj/$flavor/driver
done
gzip < ./source/docs/nx_nic.4 > ./source/docs/nx_nic.4.gz

%install
export INSTALL_MOD_PATH=$RPM_BUILD_ROOT
export INSTALL_MOD_DIR=extra/%{name}
if [ "%{_vendor}" == "suse" ]; then
export INSTALL_MOD_DIR=updates/%{name}
fi
for flavor in %flavors; do
make  -C %{compile_with}  modules_install M=$PWD/obj/$flavor/driver
done
mkdir -p $RPM_BUILD_ROOT/opt/nx_nic/
install -D -m 644 ./source/docs/nx_nic.4.gz $RPM_BUILD_ROOT/%{_mandir}/man4/nx_nic.4.gz
install -D -m 755 ./source/bin/nx3fwct.bin $RPM_BUILD_ROOT/lib/firmware/nx3fwct.bin
install -D -m 755 ./source/bin/nx3fwmn.bin $RPM_BUILD_ROOT/lib/firmware/nx3fwmn.bin
install -D -m 755 ./source/bin/nxromimg.bin $RPM_BUILD_ROOT/lib/firmware/nxromimg.bin
install -D -m 755 %{SOURCE2} $RPM_BUILD_ROOT/opt/nx_nic/nx_nic_tools_post.sh
install -D -m 755 %{SOURCE3} $RPM_BUILD_ROOT/opt/nx_nic/nx_nic_tools_preun.sh

%clean
rm -rf %{buildroot}

%post tools
# If the GPL Nic driver exists on this machine then blacklist it.
/opt/nx_nic/nx_nic_tools_post.sh

%preun tools
/opt/nx_nic/nx_nic_tools_preun.sh

%if "%{xen_srvr}" == "1"
%files kdump-%{kernel_version}
%defattr(-, root, root)
%attr(644,root,root) /lib/modules/%{kverrel}kdump/extra/%{nx_name}/nx_nic.ko

%files xen-%{kernel_version}
%defattr(-, root, root)
%attr(644,root,root) /lib/modules/%{kverrel}xen/extra/%{nx_name}/nx_nic.ko
%endif

%if "%{rhel4}" == "1"
%post
depmod

%files
%defattr(-, root, root)
%attr(644,root,root) /lib/modules/%{kernel}/extra/nx_nic.ko
%endif


%files tools
%defattr(-, root, root)
%{_mandir}/man4/nx_nic.4.gz
%attr(755,root,root) /lib/firmware/nx3fwct.bin
%attr(755,root,root) /lib/firmware/nx3fwmn.bin
%attr(755,root,root) /lib/firmware/nxromimg.bin
%attr(755,root,root) /opt/nx_nic/nx_nic_tools_post.sh
%attr(755,root,root) /opt/nx_nic/nx_nic_tools_preun.sh

%define major_change (Severity: Critical)
%define medium_change (Severity: Medium)
%define minor_change (Severity: Minor)

%changelog
* Wed Oct 24 2012 HP Linux SW Deliverables <Linux_SWdeliverables@external.groups.hp.com> %version-%release
- Adds ability to log driver version on module load %medium_change
- Adds support for ethtool to report correct LRO status %medium_change
- Adds support to report MDI-X status of copper wire interface to ethtool
  %medium_change
